﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using Advanced_Combat_Tracker;
using System.IO;
using System.Reflection;
using System.Xml;
using System.Text.RegularExpressions;

[assembly: AssemblyTitle("Russian Parsing Engine")]
[assembly: AssemblyDescription("Plugin based parsing engine for Russian EQ2 servers")]
[assembly: AssemblyCompany("Aditu of Permafrost")]
[assembly: AssemblyVersion("1.0.0.1")]

namespace ACT_Plugin
{
	public class ACT_Russian_Parser : UserControl, IActPluginV1
	{
		#region Designer generated code (Avoid editing)
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.IContainer components = null;

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		/// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
		protected override void Dispose(bool disposing)
		{
			if (disposing && (components != null))
			{
				components.Dispose();
			}
			base.Dispose(disposing);
		}

		#region Component Designer generated code

		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.cbMultiDamageIsOne = new System.Windows.Forms.CheckBox();
			this.cbSwarmIsMaster = new System.Windows.Forms.CheckBox();
			this.cbRecalcWardedHits = new System.Windows.Forms.CheckBox();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.lblHelp = new System.Windows.Forms.Label();
			this.groupBox1.SuspendLayout();
			this.SuspendLayout();
			// 
			// cbMultiDamageIsOne
			// 
			this.cbMultiDamageIsOne.AutoSize = true;
			this.cbMultiDamageIsOne.Checked = true;
			this.cbMultiDamageIsOne.CheckState = System.Windows.Forms.CheckState.Checked;
			this.cbMultiDamageIsOne.Location = new System.Drawing.Point(26, 27);
			this.cbMultiDamageIsOne.Name = "cbMultiDamageIsOne";
			this.cbMultiDamageIsOne.Size = new System.Drawing.Size(362, 17);
			this.cbMultiDamageIsOne.TabIndex = 5;
			this.cbMultiDamageIsOne.Text = "Record a hit with multiple damage types as a single hit. (Not retroactive)";
			this.cbMultiDamageIsOne.MouseHover += new System.EventHandler(this.cbMultiDamageIsOne_MouseHover);
			// 
			// cbSwarmIsMaster
			// 
			this.cbSwarmIsMaster.AutoSize = true;
			this.cbSwarmIsMaster.Checked = true;
			this.cbSwarmIsMaster.CheckState = System.Windows.Forms.CheckState.Checked;
			this.cbSwarmIsMaster.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
			this.cbSwarmIsMaster.Location = new System.Drawing.Point(26, 46);
			this.cbSwarmIsMaster.Name = "cbSwarmIsMaster";
			this.cbSwarmIsMaster.Size = new System.Drawing.Size(306, 17);
			this.cbSwarmIsMaster.TabIndex = 6;
			this.cbSwarmIsMaster.Text = "Merge pet attacks into their Master\'s data.  (Not retroactive)";
			this.cbSwarmIsMaster.MouseHover += new System.EventHandler(this.cbSwarmIsMaster_MouseHover);
			// 
			// cbRecalcWardedHits
			// 
			this.cbRecalcWardedHits.AutoSize = true;
			this.cbRecalcWardedHits.Checked = true;
			this.cbRecalcWardedHits.CheckState = System.Windows.Forms.CheckState.Checked;
			this.cbRecalcWardedHits.Location = new System.Drawing.Point(25, 65);
			this.cbRecalcWardedHits.Name = "cbRecalcWardedHits";
			this.cbRecalcWardedHits.Size = new System.Drawing.Size(310, 17);
			this.cbRecalcWardedHits.TabIndex = 7;
			this.cbRecalcWardedHits.Text = "Recalculate warded hits to their true value.  (Not retroactive)";
			this.cbRecalcWardedHits.MouseHover += new System.EventHandler(this.cbRecalcWardedHits_MouseHover);
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.Add(this.lblHelp);
			this.groupBox1.Location = new System.Drawing.Point(3, 134);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(527, 238);
			this.groupBox1.TabIndex = 8;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Help Info";
			// 
			// lblHelp
			// 
			this.lblHelp.Dock = System.Windows.Forms.DockStyle.Fill;
			this.lblHelp.Location = new System.Drawing.Point(3, 16);
			this.lblHelp.Name = "lblHelp";
			this.lblHelp.Padding = new System.Windows.Forms.Padding(5);
			this.lblHelp.Size = new System.Drawing.Size(521, 219);
			this.lblHelp.TabIndex = 0;
			this.lblHelp.Text = "Mouse-over a setting for a more detailed explanation.";
			// 
			// ACT_Russian_Parser
			// 
			this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
			this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
			this.Controls.Add(this.groupBox1);
			this.Controls.Add(this.cbMultiDamageIsOne);
			this.Controls.Add(this.cbSwarmIsMaster);
			this.Controls.Add(this.cbRecalcWardedHits);
			this.Name = "ACT_Russian_Parser";
			this.Size = new System.Drawing.Size(533, 375);
			this.groupBox1.ResumeLayout(false);
			this.ResumeLayout(false);
			this.PerformLayout();

		}

		#endregion
		#endregion
		public ACT_Russian_Parser()
		{
			InitializeComponent();
		}

		Label lblStatus;	// The status label that appears in ACT's Plugin tab
		string settingsFile = Path.Combine(ActGlobals.oFormActMain.AppDataFolder.FullName, "Config\\ACT_Russian_Parser.config.xml");
		private CheckBox cbMultiDamageIsOne;
		private CheckBox cbSwarmIsMaster;
		private CheckBox cbRecalcWardedHits;
		private GroupBox groupBox1;
		private Label lblHelp;
		SettingsSerializer xmlSettings;

		public void InitPlugin(TabPage pluginScreenSpace, Label pluginStatusText)
		{
			lblStatus = pluginStatusText;	// Hand the status label's reference to our local var
			pluginScreenSpace.Controls.Add(this);	// Add this UserControl to the tab ACT provides
			this.Dock = DockStyle.Fill;	// Expand the UserControl to fill the tab's client space
			xmlSettings = new SettingsSerializer(this);	// Create a new settings serializer and pass it this instance
			LoadSettings();

			PopulateRegexArray();
			ActGlobals.oFormActMain.BeforeLogLineRead += new LogLineEventDelegate(oFormActMain_BeforeLogLineRead);
				lblStatus.Text = "Plugin Started";
		}
		public void DeInitPlugin()
		{
			ActGlobals.oFormActMain.BeforeLogLineRead -= oFormActMain_BeforeLogLineRead;

			SaveSettings();
			lblStatus.Text = "Plugin Exited";
		}

		#region Parsing
		Regex[] regexArray;
		const string logTimeStampRegexStr = @"\(\d{10}\)\[.{24}\] ";
		DateTime lastWardTime = DateTime.MinValue;
		int lastWardAmount = 0;
		string lastWardedTarget = string.Empty;
		Regex mobLocSplit = new Regex("(?<mob>.+?) in .+", RegexOptions.Compiled);

		private void PopulateRegexArray()
		{
			regexArray = new Regex[12];
			regexArray[0] = new Regex(logTimeStampRegexStr + @"(?:Персонаж )?(?<attacker>.+?) атакуете? (?:персонаж[ае]? )?(?<victim>.+?) и наносите? (?<damageAndAttackType>.+) повреждений\.(?: \((?<special>.+)\))?", RegexOptions.Compiled);
			regexArray[1] = new Regex(logTimeStampRegexStr + @"(?<attacker>Ваше)? ?[Зз]аклинание (?<skillType>.+?) (?:персонажа (?<attacker>.+?) )?наносит (?:персонажу )?(?<victim>.+?) (?<damageAndAttackType>\d.+?) повреждений\.(?: \((?<special>.+)\))?", RegexOptions.Compiled);
			regexArray[2] = new Regex(logTimeStampRegexStr + @"(?:Персонаж )?(?<attacker>.+?) пытает(?:ся|есь) атаковать (?:персонаж[ае]? )?(?<victim>.+?)(?:, используя (?<skilltype>.+?))?, но (?<failreason>.+)\.(?: \((?<special>.+)\))?", RegexOptions.Compiled);
			regexArray[3] = new Regex(logTimeStampRegexStr + @"(?<attacker>Ваше)? ?[Зз]аклинание (?<skillType>.+?) (?:персонажа (?<attacker>.+?) )?(?<crit>критически )?исцеляет (?:персонаж )?(?<victim>.+?) на (?<damage>\d+) HP\.", RegexOptions.Compiled);
			regexArray[4] = new Regex(logTimeStampRegexStr + @"(?<attackerAndSkill>.+?) (?<crit>бьете?|критическим ударом поражаете?) (?:персонажа? )?(?<victim>.+?), но не может нанести никаких повреждений\.", RegexOptions.Compiled);
			regexArray[5] = new Regex(logTimeStampRegexStr + @"(?<attacker>Ваше)? ?[Зз]аклинание (?<skillType>.+?) (?:персонажа (?<attacker>.+?) )?поглощает (?<damage>\d+) ед\. (?:повреждений, )?предназначенных (?:персонажу? )?(?<victim>.+?)(?: повреждений)?\.", RegexOptions.Compiled);
			regexArray[6] = new Regex(logTimeStampRegexStr + @"(?:(?<attacker>Вы) применяете заклинание (?<skillType>.+?) к персонажу (?<victim>.+?) и высасываете|Заклинание (?<skillType>.+?) персонажа (?<attacker>.+?) высасывает из (?:персонажа )?(?<victim>.+?)) (?<damage>\d+) ед\. энергии\.(?: \((?<crit>.+)\))?", RegexOptions.Compiled);
			regexArray[7] = new Regex(logTimeStampRegexStr + @"(?<attacker>.+?) убивает:? (?:персонажа? )?(?<victim>.+?)(?: в зоне .+)?\.", RegexOptions.Compiled);
			regexArray[8] = new Regex(logTimeStampRegexStr + @"Неизвестная команда: 'act (.+)'", RegexOptions.Compiled);
			regexArray[9] = new Regex(logTimeStampRegexStr + @"You have entered (?::.+?:)?(?<zone>.+)\.", RegexOptions.Compiled);
			regexArray[10] = new Regex(logTimeStampRegexStr + @"(?:(?<attacker>Ваше) )?[Зз]аклинание (?<skillname>.+?) (?:персонажа (?<attacker>.+?) )?(?<crit>(?:критически )?исцеляет) (?:\(А\) )?(?:персонаж )?(?<victim>.+?) на (?<damage>\d+) энергия\.", RegexOptions.Compiled);
			regexArray[11] = new Regex(logTimeStampRegexStr + @"(?:(?<skilltype>.+?) (?:персонаж[ае] )(?<healer>.+?)|(?<healer>ВАША) способность (?<skilltype>.+?)) исцеляет эффект (?<effect>.+?) (?i:на) (?:персонаж[ае] )?(?<victim>.+)\.", RegexOptions.Compiled);
		}
		void oFormActMain_BeforeLogLineRead(bool isImport, LogLineEventArgs logInfo)
		{
			for (int i = 0; i < regexArray.Length; i++)
			{
				if (regexArray[i].IsMatch(logInfo.logLine))
				{
					LogExeRussian(i + 1, logInfo.logLine, isImport);
					break;
				}
			}
		}

		private void LogExeRussian(int logMatched, string logLine, bool isImport)
		{
			string attacker, victim, damage, skillType, why, crit, special, attackType;
			Regex rE = regexArray[logMatched - 1];
			bool critical;
			int sposIndex, aposIndex;

			DateTime time = ActGlobals.oFormActMain.LastKnownTime;
			List<DamageAndType> damageAndTypeArr;

			Dnum failType;
			int gts = ActGlobals.oFormActMain.GlobalTimeSorter;

			//if(logLine.Contains("от падения повреждений"))
			//    Debugger.Break();
			if (logLine.Contains("падает повреждений."))
				logMatched = 0;
			switch (logMatched)
			{
				#region Case 1 [melee attacks]
				case 1:
					attacker = rE.Replace(logLine, "$1");
					victim = rE.Replace(logLine, "$2");
					damage = rE.Replace(logLine, "$3");		// Also damage type
					special = rE.Replace(logLine, "$4");

					if (special.Contains("критичес"))
						critical = true;
					else
						critical = false;
					special = RusGetSpecialString(special);

					attacker = RussianPersonaReplace(attacker);
					victim = RussianPersonaReplace(victim);

					damageAndTypeArr = RusGetDamageAndTypeArr(damage);

					if (cbSwarmIsMaster.Checked && attacker.Contains("(") && attacker.Contains(")"))
					{
						int parIndex = attacker.IndexOf('(');
						skillType = RusGetPetSkilltypeString(attacker, string.Empty, parIndex);
						attacker = RusGetPetAttackerString(attacker, parIndex);
						if (attacker == victim)
							break;		// You don't get credit for attacking yourself or your own pet
						if (ActGlobals.oFormActMain.SetEncounter(time, attacker, victim))
						{
							AddDamageAttack(attacker, victim, skillType, (int)SwingTypeEnum.NonMelee, critical, special, damageAndTypeArr, time, gts);
						}
						break;
					}

					if (attacker == victim)
						break;		// You don't get credit for attacking yourself or your own pet
					if (ActGlobals.oFormActMain.SetEncounter(time, attacker, victim))
					{
						AddDamageAttack(attacker, victim, string.Empty, (int)SwingTypeEnum.Melee, critical, special, damageAndTypeArr, time, gts);
					}
					break;
				#endregion
				#region Case 2 [skill attacks]
				case 2:
					attacker = rE.Replace(logLine, "$1");
					skillType = rE.Replace(logLine, "$2");
					victim = rE.Replace(logLine, "$3");
					damage = rE.Replace(logLine, "$4");
					special = rE.Replace(logLine, "$5");
					attacker = String.IsNullOrEmpty(attacker) ? "Unknown" : attacker;

					damageAndTypeArr = RusGetDamageAndTypeArr(damage);

					if (special.Contains("критичес"))
						critical = true;
					else
						critical = false;
					special = RusGetSpecialString(special);

					attacker = RussianPersonaReplace(attacker);
					victim = RussianPersonaReplace(victim);

					if (cbSwarmIsMaster.Checked && attacker.Contains("(") && attacker.Contains(")"))
					{
						int parIndex = attacker.IndexOf('(');
						skillType = RusGetPetSkilltypeString(attacker, skillType, parIndex);
						attacker = RusGetPetAttackerString(attacker, parIndex);
					}

					if (attacker == victim)
						break;		// You don't get credit for attacking yourself or your own pet
					if (ActGlobals.oFormActMain.SetEncounter(time, attacker, victim))
					{
						AddDamageAttack(attacker, victim, skillType, (int)SwingTypeEnum.NonMelee, critical, special, damageAndTypeArr, time, gts);
					}

					break;
				#endregion
				#region Case 3 [failed attack]
				case 3:
					attacker = rE.Replace(logLine, "$1");
					victim = rE.Replace(logLine, "$2"); // Possibly skilltype
					why = rE.Replace(logLine, "$3");
					special = rE.Replace(logLine, "$4");
					special = String.IsNullOrEmpty(special) ? "None" : special;
					skillType = string.Empty;

					critical = false;

					aposIndex = victim.IndexOf("при помощи");
					if (aposIndex > -1)
					{
						skillType = victim.Substring(aposIndex + 11, victim.Length - aposIndex - 11);
						victim = victim.Substring(0, aposIndex - 1);
						attacker = RussianPersonaReplace(attacker);
						victim = RussianPersonaReplace(victim);
						failType = GetFailTypeRussian(victim, why, ref special);


						if (cbSwarmIsMaster.Checked && attacker.Contains("(") && attacker.Contains(")"))
						{
							int parIndex = attacker.IndexOf('(');
							skillType = RusGetPetSkilltypeString(attacker, skillType, parIndex);
							attacker = RusGetPetAttackerString(attacker, parIndex);
						}

						if (attacker == victim)
							break;		// You don't get credit for attacking yourself or your own pet
						if (ActGlobals.oFormActMain.SetEncounter(time, attacker, victim))
						{
							ActGlobals.oFormActMain.AddCombatAction((int)SwingTypeEnum.NonMelee, false, special, attacker, skillType, failType, time, gts, victim, "non-melee");
						}
					}
					else
					{
						attacker = RussianPersonaReplace(attacker);
						victim = RussianPersonaReplace(victim);
						failType = GetFailTypeRussian(victim, why, ref special);

						if (cbSwarmIsMaster.Checked && attacker.Contains("(") && attacker.Contains(")"))
						{
							int parIndex = attacker.IndexOf('(');
							skillType = RusGetPetSkilltypeString(attacker, skillType, parIndex);
							attacker = RusGetPetAttackerString(attacker, parIndex);
							if (attacker == victim)
								break;		// You don't get credit for attacking yourself or your own pet
							if (ActGlobals.oFormActMain.SetEncounter(time, attacker, victim))
							{
								ActGlobals.oFormActMain.AddCombatAction((int)SwingTypeEnum.NonMelee, false, special, attacker, skillType, failType, time, gts, victim, "non-melee");
							}
							break;
						}

						if (attacker == victim)
							break;		// You don't get credit for attacking yourself or your own pet


						if (String.IsNullOrEmpty(skillType))
						{
							if (ActGlobals.oFormActMain.SetEncounter(time, attacker, victim))
							{
								ActGlobals.oFormActMain.AddCombatAction((int)SwingTypeEnum.Melee, false, special, attacker, "melee", failType, time, gts, victim, "melee");
							}
						}
						else
						{
							if (ActGlobals.oFormActMain.SetEncounter(time, attacker, victim))
							{
								ActGlobals.oFormActMain.AddCombatAction((int)SwingTypeEnum.NonMelee, false, special, attacker, skillType, failType, time, gts, victim, "non-melee");
							}
						}
					}
					break;
				#endregion
				#region Case 4 [healing]
				case 4:
					if (!ActGlobals.oFormActMain.InCombat)
						break;
					attacker = rE.Replace(logLine, "$1");
					skillType = rE.Replace(logLine, "$2");
					crit = rE.Replace(logLine, "$3");
					victim = rE.Replace(logLine, "$4");
					damage = rE.Replace(logLine, "$5");

					critical = crit.Contains("критичес");		// Check for critical hits

					attacker = RussianPersonaReplace(attacker);
					victim = RussianPersonaReplace(victim);

					if (cbSwarmIsMaster.Checked && attacker.Contains("(") && attacker.Contains(")"))
					{
						int parIndex = attacker.IndexOf('(');
						skillType = RusGetPetSkilltypeString(attacker, skillType, parIndex);
						attacker = RusGetPetAttackerString(attacker, parIndex);
					}

					ActGlobals.oFormActMain.AddCombatAction((int)SwingTypeEnum.Healing, critical, "None", attacker, skillType, Int32.Parse(damage), time, gts, victim, "Hitpoints");
					break;
				#endregion
				#region Case 5 [no-damage hit]
				case 5:
					attacker = rE.Replace(logLine, "$1"); // Possible skill
					crit = rE.Replace(logLine, "$2");
					victim = rE.Replace(logLine, "$3");
					skillType = string.Empty;
					special = "None";
					List<DamageAndType> noDamageCA = new List<DamageAndType>(1);
					noDamageCA.Add(new DamageAndType(0, "non-melee"));

					if (crit.Contains("критическ"))		// Check for critical hits
						critical = true;
					else
						critical = false;
					special = RusGetSpecialString(crit);

					sposIndex = attacker.IndexOf("с помощью");
					if (sposIndex > -1)
					{
						aposIndex = attacker.IndexOf('"');
						skillType = attacker.Substring(aposIndex + 1, attacker.Length - aposIndex - 2);
						attacker = attacker.Substring(0, sposIndex - 1);
						attacker = RussianPersonaReplace(attacker);
						victim = RussianPersonaReplace(victim);

						if (cbSwarmIsMaster.Checked && attacker.Contains("(") && attacker.Contains(")"))
						{
							int parIndex = attacker.IndexOf('(');
							skillType = RusGetPetSkilltypeString(attacker, skillType, parIndex);
							attacker = RusGetPetAttackerString(attacker, parIndex);
						}

						if (attacker == victim)
							break;		// You don't get credit for attacking yourself or your own pet
						if (ActGlobals.oFormActMain.SetEncounter(time, attacker, victim))
						{
							AddDamageAttack(attacker, victim, skillType, (int)SwingTypeEnum.NonMelee, critical, special, noDamageCA, time, gts);
						}
					}
					else
					{
						sposIndex = victim.IndexOf("с помощью");
						if (sposIndex > -1)
						{
							aposIndex = victim.IndexOf('"');
							skillType = victim.Substring(aposIndex + 1, victim.Length - aposIndex - 2);
							victim = victim.Substring(0, sposIndex - 1);
							attacker = RussianPersonaReplace(attacker);
							victim = RussianPersonaReplace(victim);

							if (cbSwarmIsMaster.Checked && attacker.Contains("(") && attacker.Contains(")"))
							{
								int parIndex = attacker.IndexOf('(');
								skillType = RusGetPetSkilltypeString(attacker, skillType, parIndex);
								attacker = RusGetPetAttackerString(attacker, parIndex);
							}

							if (attacker == victim)
								break;		// You don't get credit for attacking yourself or your own pet
							if (ActGlobals.oFormActMain.SetEncounter(time, attacker, victim))
							{
								AddDamageAttack(attacker, victim, skillType, (int)SwingTypeEnum.NonMelee, critical, special, noDamageCA, time, gts);
							}
						}
						else
						{
							attacker = RussianPersonaReplace(attacker);
							victim = RussianPersonaReplace(victim);

							if (cbSwarmIsMaster.Checked && attacker.Contains("(") && attacker.Contains(")"))
							{
								int parIndex = attacker.IndexOf('(');
								skillType = RusGetPetSkilltypeString(attacker, skillType, parIndex);
								attacker = RusGetPetAttackerString(attacker, parIndex);
								if (attacker == victim)
									break;		// You don't get credit for attacking yourself or your own pet
								if (ActGlobals.oFormActMain.SetEncounter(time, attacker, victim))
								{
									AddDamageAttack(attacker, victim, skillType, (int)SwingTypeEnum.NonMelee, critical, special, noDamageCA, time, gts);
								}
								break;
							}

							if (attacker == victim)
								break;		// You don't get credit for attacking yourself or your own pet
							if (ActGlobals.oFormActMain.SetEncounter(time, attacker, victim))
							{
								List<DamageAndType> noDamageMelee = new List<DamageAndType>(1);
								noDamageMelee.Add(new DamageAndType(0, "melee"));
								AddDamageAttack(attacker, victim, "", (int)SwingTypeEnum.Melee, critical, special, noDamageMelee, time, gts);
							}
						}
					}
					break;
				#endregion
				#region Case 6 [ward absorbtion]
				case 6:
					if (!ActGlobals.oFormActMain.InCombat)
						break;
                    attacker = rE.Replace(logLine, "$1");
					skillType = rE.Replace(logLine, "$2");
					damage = rE.Replace(logLine, "$3");
					victim = rE.Replace(logLine, "$4");

                    attacker = RussianPersonaReplace(attacker);

					victim = RussianPersonaReplace(victim);

					ActGlobals.oFormActMain.AddCombatAction((int)SwingTypeEnum.Healing, false, "None", attacker, skillType, Int32.Parse(damage), time, gts, victim, "Absorption");
					if (CheckWardedHit(victim, time))
						lastWardAmount += Int32.Parse(damage);
					else
						lastWardAmount = Int32.Parse(damage);
					lastWardedTarget = victim;
					lastWardTime = time;
					break;
				#endregion
				#region Case 7 [power drain]
				case 7:
					attacker = rE.Replace(logLine, "$1");
					skillType = rE.Replace(logLine, "$2");
					victim = rE.Replace(logLine, "$3");
					damage = rE.Replace(logLine, "$4");
					crit = rE.Replace(logLine, "$5");

					if (crit.Contains("критичес"))
						critical = true;
					else
						critical = false;
					if (attacker.StartsWith("\"") && attacker.EndsWith("\""))
					{
						skillType = attacker.Substring(1, attacker.Length - 2);
						attacker = ActGlobals.charName;
					}
					attacker = RussianPersonaReplace(attacker);
					victim = RussianPersonaReplace(victim);

					if (cbSwarmIsMaster.Checked && attacker.Contains("(") && attacker.Contains(")"))
					{
						int parIndex = attacker.IndexOf('(');
						skillType = RusGetPetSkilltypeString(attacker, skillType, parIndex);
						attacker = RusGetPetAttackerString(attacker, parIndex);
					}

					if (attacker == victim)
						break;
					if (ActGlobals.oFormActMain.SetEncounter(time, attacker, victim))
					{
						if (CheckWardedHit(victim, time))
						{
							Dnum complexWardedHit = new Dnum(Int32.Parse(damage) + lastWardAmount, String.Format("{0}/{1}", lastWardAmount, damage));
							ActGlobals.oFormActMain.AddCombatAction((int)SwingTypeEnum.PowerDrain, critical, "None", attacker, skillType, complexWardedHit, time, gts, victim, "warded/non-melee");
							lastWardAmount = 0;
						}
						else
							ActGlobals.oFormActMain.AddCombatAction((int)SwingTypeEnum.PowerDrain, critical, "None", attacker, skillType, Int32.Parse(damage), time, gts, victim, "non-melee");
					}
					break;
				#endregion
				#region Case 8 [killing]
				case 8:
					attacker = RussianPersonaReplace(rE.Replace(logLine, "$1"));
					victim = RussianPersonaReplace(rE.Replace(logLine, "$2"));

					if (cbSwarmIsMaster.Checked && attacker.Contains("(") && attacker.Contains(")"))
					{
						int parIndex = attacker.IndexOf('(');
						attacker = RusGetPetAttackerString(attacker, parIndex);
					}
					ActGlobals.oFormSpellTimers.RemoveTimerMods(victim);
					if (ActGlobals.oFormActMain.InCombat)
					{
						ActGlobals.oFormActMain.AddCombatAction((int)SwingTypeEnum.NonMelee, false, "None", attacker, "Killing", Dnum.Death, time, gts, victim, "Death");

						//if (cbKillEnd.Checked && ActGlobals.oFormActMain.ActiveZone.ActiveEncounter.GetAllies().IndexOf(new CombatantData(attacker, null)) > -1)
						//    ActGlobals.oFormActMain.EndCombat(true);
					}
					break;
				#endregion
				#region Case 9 [act commands]
				case 9:
					ActGlobals.oFormActMain.ActCommands(rE.Replace(logLine, "$1"));
					break;
				#endregion
				#region Case 10 [zone change]
				case 10:
					if (logLine.Contains(" combat by "))
						break;
					ActGlobals.oFormActMain.ChangeZone(rE.Replace(logLine, "$1").Trim());
					break;
				#endregion
				#region Case 11 [power replenish]
				case 11:
					if (!ActGlobals.oFormActMain.InCombat)
						break;
					attacker = rE.Replace(logLine, "$1");
					skillType = rE.Replace(logLine, "$2");
					crit = rE.Replace(logLine, "$3");
					victim = rE.Replace(logLine, "$4");
					damage = rE.Replace(logLine, "$5");

					if (crit.Contains("критически"))
						critical = true;
					else
						critical = false;

					attacker = RussianPersonaReplace(attacker);
					victim = RussianPersonaReplace(victim);

					ActGlobals.oFormActMain.AddCombatAction((int)SwingTypeEnum.PowerHealing, critical, "None", attacker, skillType, Int32.Parse(damage), time, gts, victim, "Power");
					break;
				#endregion
				#region Case 12 [dispell/cure]
				case 12:
					skillType = rE.Replace(logLine, "$1");
					attacker = rE.Replace(logLine, "$2");
					attackType = rE.Replace(logLine, "$3");
					victim = rE.Replace(logLine, "$4");

					attacker = RussianPersonaReplace(attacker);
					victim = RussianPersonaReplace(victim);

					if (attackType == "Травмирующий удар силача")
						ActGlobals.oFormSpellTimers.DispellTimerMods(victim);

					if (ActGlobals.oFormActMain.InCombat)
						ActGlobals.oFormActMain.AddCombatAction((int)SwingTypeEnum.CureDispel, false, attackType, attacker, skillType, 1, time, gts, victim, "исцеляет");
					break;
				#endregion

				default:
					break;
			}
		}
		private bool CheckWardedHit(string victim, DateTime time)
		{
			return cbRecalcWardedHits.Checked && lastWardTime == time && lastWardedTarget == victim && lastWardAmount > 0;
		}
		private string RusGetSpecialString(string Special)
		{
			Special = Special.Replace("атака", string.Empty).Trim();
			Special = Special.Replace("атаку", string.Empty).Trim();
			Special = Special.Replace("критический", string.Empty).Trim();
			Special = Special.Replace("критическая", string.Empty).Trim();
			Special = Special.Replace("удар", string.Empty).Trim();
			if (Special == String.Empty)
				return "None";
			return Special;
		}
		private static List<DamageAndType> RusGetDamageAndTypeArr(string damageAndType)
		{
			damageAndType = damageAndType.Replace("  ", " ");
			damageAndType = damageAndType.Replace(" и ", ", ");
			damageAndType = damageAndType.Replace(" ед. ", " ");
			damageAndType = damageAndType.Trim();
			string[] results = damageAndType.Split(new string[] { ", " }, StringSplitOptions.RemoveEmptyEntries);
			List<DamageAndType> outList = new List<DamageAndType>();
			for (int i = 0; i < results.Length; i++)
			{
				outList.Add(new DamageAndType(results[i]));
			}
			return outList;
		}
		private static string RusGetPetAttackerString(string attacker, int parIndex)
		{
			return attacker.Substring(parIndex + 1, attacker.Length - parIndex - 2);
		}
		private static string RusGetPetSkilltypeString(string attacker, string skillType, int parIndex)
		{
			if (String.IsNullOrEmpty(skillType))
			{
				return String.Format("({0})", attacker.Substring(0, parIndex - 1));
			}
			else
			{
				return String.Format("({0}) - {1}", attacker.Substring(0, parIndex - 1), skillType);
			}
		}
		private Dnum GetFailTypeRussian(string Victim, string Why, ref string Special)
		{
			bool specialSet = false;
			string why = Why;
			Special = Special.Replace("проводите", String.Empty).Trim();
			Special = Special.Replace("удар на", String.Empty).Trim();
			Special = Special.Replace("на атаку", String.Empty).Trim();
			Special = Special.Replace("атаку", String.Empty).Trim();
			Special = Special.Replace("атака", String.Empty).Trim();

			if (Special.Contains("двойную"))
			{
				why = Special.Replace("двойную", string.Empty).Trim();
				Special = "двойная";
				specialSet = true;
			}
			if (Special.Contains("двойная"))
			{
				why = Special.Replace("двойная", string.Empty).Trim();
				Special = "двойная";
				specialSet = true;
			}

			if (Special.Contains("вихревая"))
			{
				why = Special.Replace("вихревая", string.Empty).Trim();
				Special = "вихревая";
				specialSet = true;
			}
			if (Special.Contains("вихревую"))
			{
				why = Special.Replace("вихревую", string.Empty).Trim();
				Special = "вихревая";
				specialSet = true;
			}

			if (Special.Contains("по площади"))
			{
				why = Special.Replace("по площади", string.Empty).Trim();
				Special = "по площади";
				specialSet = true;
			}

			why = why.Replace("вы ", ActGlobals.charName + " ").Trim();
			why = why.Replace(Victim, String.Empty).Trim();
			why = why.Replace("  ", " ");
			if (why.Contains("перехватывает") || why.Contains("уклоняетесь"))
			{
				why = why.Replace("перехватывает", Special);
				why = why.Replace("уклоняетесь", Special);
				if (!specialSet)
					Special = "None";
			}

			if (why.Contains("промахивает"))
				return Dnum.Miss;
			if (String.IsNullOrEmpty(why))
				return Dnum.Miss;
			return new Dnum(-9, why.Trim());
		}
		private string RussianPersonaReplace(string input)
		{
			if (input == "ВАША")
				return ActGlobals.charName;
			if (input == "ВАС")
				return ActGlobals.charName;
			if (input == "Ваше")
				return ActGlobals.charName;
			if (input.ToLower() == "вас")
				return ActGlobals.charName;
			if (input.ToLower() == "вы")
				return ActGlobals.charName;
			if (input.ToLower() == "себе")
				return ActGlobals.charName;
			if (input.ToLower() == "вам")
				return ActGlobals.charName;
			return input;
		}
		private void AddDamageAttack(string attacker, string victim, string skillType, int swingType, bool critical, string special, List<DamageAndType> damageAndTypeArr, DateTime time, int gts)
		{
			int damageTotal = 0;
			if (cbMultiDamageIsOne.Checked)
			{
				string damageStr = string.Empty;
				string typeStr = string.Empty;
				if (CheckWardedHit(victim, time))
				{
					damageTotal = lastWardAmount;
					damageStr += String.Format("{0}/", damageTotal);
					typeStr += String.Format("{0}/", "warded");
					lastWardAmount = 0;
				}
				for (int i = 0; i < damageAndTypeArr.Count; i++)
				{
					damageTotal += damageAndTypeArr[i].Damage;
					damageStr += String.Format("{0}/", damageAndTypeArr[i].Damage);
					typeStr += String.Format("{0}/", damageAndTypeArr[i].Type);
				}
				damageStr = damageStr.TrimEnd(new char[] { '/' });
				typeStr = typeStr.TrimEnd(new char[] { '/' });
				if (String.IsNullOrEmpty(skillType))
					skillType = typeStr;
				ActGlobals.oFormActMain.AddCombatAction(swingType, critical, special, attacker, skillType, new Dnum(damageTotal, damageStr), time, gts, victim, typeStr);
			}
			else
			{
				bool nullSkillType = false;
				if (String.IsNullOrEmpty(skillType))
					nullSkillType = true;
				for (int i = 0; i < damageAndTypeArr.Count; i++)
				{
					damageTotal += damageAndTypeArr[i].Damage;
					if (nullSkillType)
						skillType = damageAndTypeArr[i].Type;
					if (i == damageAndTypeArr.Count - 1 && CheckWardedHit(victim, time))
					{
						damageTotal += lastWardAmount;
						lastWardAmount = 0;
					}
					ActGlobals.oFormActMain.AddCombatAction(swingType, critical, special, attacker, skillType, damageTotal, time, gts, victim, damageAndTypeArr[i].Type);
				}
			}
		}

		private class DamageAndType
		{
			int damage;
			string type;
			/// <summary>
			/// Data class for a single type of damage and the amount
			/// </summary>
			/// <param name="Damage">The positive integer amount of damage</param>
			/// <param name="Type">The type of damage to display it as</param>
			public DamageAndType(int Damage, string Type)
			{
				this.damage = Damage;
				this.type = Type;
			}
			/// <summary>
			/// Data class for a single type of damage and the amount
			/// </summary>
			/// <param name="UnsplitSource">An input string such as "123 crushing" to be split by the constructor</param>
			public DamageAndType(string UnsplitSource)
			{
				int spacePos = UnsplitSource.IndexOf(' ');
				if (spacePos == -1)
					throw new ArgumentException("The input string did not contain a space, thus cannot be split");
				damage = Int32.Parse(UnsplitSource.Substring(0, spacePos));
				type = UnsplitSource.Substring(spacePos + 1);
			}
			public int Damage
			{
				get { return damage; }
				set { damage = value; }
			}
			public string Type
			{
				get { return type; }
				set { type = value; }
			}
		}
		#endregion
		void LoadSettings()
		{
			// Add items to the xmlSettings object here...
			xmlSettings.AddControlSetting(cbMultiDamageIsOne.Name, cbMultiDamageIsOne);
			xmlSettings.AddControlSetting(cbRecalcWardedHits.Name, cbRecalcWardedHits);
			xmlSettings.AddControlSetting(cbSwarmIsMaster.Name, cbSwarmIsMaster);

			if (File.Exists(settingsFile))
			{
				FileStream fs = new FileStream(settingsFile, FileMode.Open, FileAccess.Read, FileShare.ReadWrite);
				XmlTextReader xReader = new XmlTextReader(fs);

				try
				{
					while (xReader.Read())
					{
						if (xReader.NodeType == XmlNodeType.Element)
						{
							if (xReader.LocalName == "SettingsSerializer")
							{
								xmlSettings.ImportFromXml(xReader);
							}
						}
					}
				}
				catch (Exception ex)
				{
					lblStatus.Text = "Error loading settings: " + ex.Message;
				}
				xReader.Close();
			}
		}
		void SaveSettings()
		{
			FileStream fs = new FileStream(settingsFile, FileMode.Create, FileAccess.Write, FileShare.ReadWrite);
			XmlTextWriter xWriter = new XmlTextWriter(fs, Encoding.UTF8);
			xWriter.Formatting = Formatting.Indented;
			xWriter.Indentation = 1;
			xWriter.IndentChar = '\t';
			xWriter.WriteStartDocument(true);
			xWriter.WriteStartElement("Config");	// <Config>
			xWriter.WriteStartElement("SettingsSerializer");	// <Config><SettingsSerializer>
			xmlSettings.ExportToXml(xWriter);	// Fill the SettingsSerializer XML
			xWriter.WriteEndElement();	// </SettingsSerializer>
			xWriter.WriteEndElement();	// </Config>
			xWriter.WriteEndDocument();	// Tie up loose ends (shouldn't be any)
			xWriter.Flush();	// Flush the file buffer to disk
			xWriter.Close();
		}

		private void cbSwarmIsMaster_MouseHover(object sender, EventArgs e)
		{
			lblHelp.Text = "When enabled, \"Wässrige Horde des Character\" and other similarly named pets will have their attack damage added to their master instead of as their own named entry.  Incoming attacks will *not* be redirected to their master's data.";
		}
		private void cbRecalcWardedHits_MouseHover(object sender, EventArgs e)
		{
			lblHelp.Text = "If enabled, no-damage hits or reduced damage hits immediately following a ward absorbtion will be increased by the absorption amount.  Stoneskin's no-damage hits cannot be recalculated.";
		}
		private void cbMultiDamageIsOne_MouseHover(object sender, EventArgs e)
		{
			lblHelp.Text = "When enabled, an attack that has multiple damage types, such as \"300 crushing, 5 poison and 5 disease damage\" will show up as one total attack: 300/5/5 crushing/poison/disease, internally seen as 310.  If disabled, each damage type will show up as an individual swing, IE three attacks: 300 crushing; 5 poison; 5 disease.  Having a single attack show up as multiple will have consequences when calculating ToHit%.";
		}
	}
}
