using System;
using System.Collections.Generic;
using System.Text;
using Advanced_Combat_Tracker;
using System.Windows.Forms;
using System.Text.RegularExpressions;
using System.Xml;
using System.IO;
using System.Reflection;
using System.Drawing;

[assembly: AssemblyTitle("Detriment Call Macro")]
[assembly: AssemblyDescription("Creates /do_file_commands files with social text warnings about players being afflicted with certain effects")]
[assembly: AssemblyCopyright("Aditu of Permafrost (EQ2) <aditu@maine.rr.com>")]
[assembly: AssemblyVersion("1.2.0.4")]

namespace ACT_Plugin
{
    class DetrimentCallMacro : UserControl, IActPluginV1
    {
        #region User Interface
        /// <summary> 
        /// Required designer variable.
        /// </summary>
        private System.ComponentModel.IContainer components = null;

        /// <summary> 
        /// Clean up any resources being used.
        /// </summary>
        /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
        protected override void Dispose(bool disposing)
        {
            if (disposing && (components != null))
            {
                components.Dispose();
            }
            base.Dispose(disposing);
        }

        private CheckedListBox clbEffects;
        private TableLayoutPanel tableLayoutPanel1;
        private Button btnAdd;
        private Button btnRemove;
        private TableLayoutPanel tableLayoutPanel2;
        private TextBox tbMob;
        private Label label2;
        private Label label1;
        private TextBox tbSpell;
        private Label label3;
        private Label label4;
        private ComboBox ddlCategory;
        private NumericUpDown nudPlayerCount;
        private Label label5;
        private NumericUpDown nudSecondCount;
        private Label label6;
        private CheckBox cbAnyMob;
        private Label label7;
        private TextBox tbExportChannel;
        private CheckBox cbSingleLine;
        private Label label9;
        private TextBox tbExportFormat;
        private Label lblInstructions;
        private Label label8;
        private ComboBox ddlSound;
        private Label label11;
        private TextBox tbExFilename;
        private Label label12;
        private CheckBox cbShowDetWindow;
        private Button btnPlayTrigger;
        private TextBox tbSound;

        private void InitializeComponent()
        {
            this.clbEffects = new System.Windows.Forms.CheckedListBox();
            this.btnAdd = new System.Windows.Forms.Button();
            this.btnRemove = new System.Windows.Forms.Button();
            this.tableLayoutPanel1 = new System.Windows.Forms.TableLayoutPanel();
            this.tableLayoutPanel2 = new System.Windows.Forms.TableLayoutPanel();
            this.tbMob = new System.Windows.Forms.TextBox();
            this.tbExportChannel = new System.Windows.Forms.TextBox();
            this.label2 = new System.Windows.Forms.Label();
            this.label7 = new System.Windows.Forms.Label();
            this.label1 = new System.Windows.Forms.Label();
            this.tbSpell = new System.Windows.Forms.TextBox();
            this.label3 = new System.Windows.Forms.Label();
            this.label4 = new System.Windows.Forms.Label();
            this.ddlCategory = new System.Windows.Forms.ComboBox();
            this.nudPlayerCount = new System.Windows.Forms.NumericUpDown();
            this.label5 = new System.Windows.Forms.Label();
            this.nudSecondCount = new System.Windows.Forms.NumericUpDown();
            this.label6 = new System.Windows.Forms.Label();
            this.cbAnyMob = new System.Windows.Forms.CheckBox();
            this.cbSingleLine = new System.Windows.Forms.CheckBox();
            this.label9 = new System.Windows.Forms.Label();
            this.tbExportFormat = new System.Windows.Forms.TextBox();
            this.lblInstructions = new System.Windows.Forms.Label();
            this.label8 = new System.Windows.Forms.Label();
            this.ddlSound = new System.Windows.Forms.ComboBox();
            this.tbSound = new System.Windows.Forms.TextBox();
            this.label11 = new System.Windows.Forms.Label();
            this.tbExFilename = new System.Windows.Forms.TextBox();
            this.label12 = new System.Windows.Forms.Label();
            this.cbShowDetWindow = new System.Windows.Forms.CheckBox();
            this.btnPlayTrigger = new System.Windows.Forms.Button();
            this.tableLayoutPanel1.SuspendLayout();
            this.tableLayoutPanel2.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.nudPlayerCount)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.nudSecondCount)).BeginInit();
            this.SuspendLayout();
            // 
            // clbEffects
            // 
            this.tableLayoutPanel1.SetColumnSpan(this.clbEffects, 2);
            this.clbEffects.Dock = System.Windows.Forms.DockStyle.Fill;
            this.clbEffects.FormattingEnabled = true;
            this.clbEffects.IntegralHeight = false;
            this.clbEffects.Location = new System.Drawing.Point(3, 3);
            this.clbEffects.Name = "clbEffects";
            this.clbEffects.Size = new System.Drawing.Size(194, 375);
            this.clbEffects.TabIndex = 10;
            this.clbEffects.SelectedIndexChanged += new System.EventHandler(this.clbEffects_SelectedIndexChanged);
            // 
            // btnAdd
            // 
            this.btnAdd.Dock = System.Windows.Forms.DockStyle.Fill;
            this.btnAdd.Location = new System.Drawing.Point(3, 384);
            this.btnAdd.Name = "btnAdd";
            this.btnAdd.Size = new System.Drawing.Size(94, 22);
            this.btnAdd.TabIndex = 11;
            this.btnAdd.Text = "Add/Edit";
            this.btnAdd.UseVisualStyleBackColor = true;
            this.btnAdd.Click += new System.EventHandler(this.btnAdd_Click);
            // 
            // btnRemove
            // 
            this.btnRemove.Dock = System.Windows.Forms.DockStyle.Fill;
            this.btnRemove.Location = new System.Drawing.Point(103, 384);
            this.btnRemove.Name = "btnRemove";
            this.btnRemove.Size = new System.Drawing.Size(94, 22);
            this.btnRemove.TabIndex = 12;
            this.btnRemove.Text = "Remove";
            this.btnRemove.UseVisualStyleBackColor = true;
            this.btnRemove.Click += new System.EventHandler(this.btnRemove_Click);
            // 
            // tableLayoutPanel1
            // 
            this.tableLayoutPanel1.ColumnCount = 2;
            this.tableLayoutPanel1.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 50F));
            this.tableLayoutPanel1.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 50F));
            this.tableLayoutPanel1.Controls.Add(this.btnAdd, 0, 1);
            this.tableLayoutPanel1.Controls.Add(this.clbEffects, 0, 0);
            this.tableLayoutPanel1.Controls.Add(this.btnRemove, 1, 1);
            this.tableLayoutPanel1.Location = new System.Drawing.Point(12, 12);
            this.tableLayoutPanel1.Name = "tableLayoutPanel1";
            this.tableLayoutPanel1.RowCount = 2;
            this.tableLayoutPanel1.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Percent, 100F));
            this.tableLayoutPanel1.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 28F));
            this.tableLayoutPanel1.Size = new System.Drawing.Size(200, 409);
            this.tableLayoutPanel1.TabIndex = 1;
            // 
            // tableLayoutPanel2
            // 
            this.tableLayoutPanel2.ColumnCount = 5;
            this.tableLayoutPanel2.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Absolute, 110F));
            this.tableLayoutPanel2.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Absolute, 121F));
            this.tableLayoutPanel2.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Absolute, 129F));
            this.tableLayoutPanel2.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Absolute, 88F));
            this.tableLayoutPanel2.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Absolute, 81F));
            this.tableLayoutPanel2.Controls.Add(this.tbMob, 1, 1);
            this.tableLayoutPanel2.Controls.Add(this.tbExportChannel, 1, 4);
            this.tableLayoutPanel2.Controls.Add(this.label2, 0, 1);
            this.tableLayoutPanel2.Controls.Add(this.label7, 0, 4);
            this.tableLayoutPanel2.Controls.Add(this.label1, 0, 0);
            this.tableLayoutPanel2.Controls.Add(this.tbSpell, 1, 0);
            this.tableLayoutPanel2.Controls.Add(this.label3, 0, 3);
            this.tableLayoutPanel2.Controls.Add(this.label4, 0, 2);
            this.tableLayoutPanel2.Controls.Add(this.ddlCategory, 1, 2);
            this.tableLayoutPanel2.Controls.Add(this.nudPlayerCount, 1, 3);
            this.tableLayoutPanel2.Controls.Add(this.label5, 2, 3);
            this.tableLayoutPanel2.Controls.Add(this.nudSecondCount, 3, 3);
            this.tableLayoutPanel2.Controls.Add(this.label6, 4, 3);
            this.tableLayoutPanel2.Controls.Add(this.cbAnyMob, 4, 1);
            this.tableLayoutPanel2.Controls.Add(this.cbSingleLine, 3, 4);
            this.tableLayoutPanel2.Controls.Add(this.label9, 0, 5);
            this.tableLayoutPanel2.Controls.Add(this.tbExportFormat, 1, 5);
            this.tableLayoutPanel2.Controls.Add(this.lblInstructions, 0, 8);
            this.tableLayoutPanel2.Controls.Add(this.label8, 0, 6);
            this.tableLayoutPanel2.Controls.Add(this.ddlSound, 1, 6);
            this.tableLayoutPanel2.Controls.Add(this.tbSound, 2, 6);
            this.tableLayoutPanel2.Controls.Add(this.label11, 0, 7);
            this.tableLayoutPanel2.Controls.Add(this.tbExFilename, 1, 7);
            this.tableLayoutPanel2.Controls.Add(this.label12, 3, 7);
            this.tableLayoutPanel2.Location = new System.Drawing.Point(218, 38);
            this.tableLayoutPanel2.Name = "tableLayoutPanel2";
            this.tableLayoutPanel2.RowCount = 9;
            this.tableLayoutPanel2.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 30F));
            this.tableLayoutPanel2.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 30F));
            this.tableLayoutPanel2.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 30F));
            this.tableLayoutPanel2.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 30F));
            this.tableLayoutPanel2.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 30F));
            this.tableLayoutPanel2.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 30F));
            this.tableLayoutPanel2.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 30F));
            this.tableLayoutPanel2.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 30F));
            this.tableLayoutPanel2.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 20F));
            this.tableLayoutPanel2.Size = new System.Drawing.Size(542, 474);
            this.tableLayoutPanel2.TabIndex = 0;
            // 
            // tbMob
            // 
            this.tableLayoutPanel2.SetColumnSpan(this.tbMob, 3);
            this.tbMob.Dock = System.Windows.Forms.DockStyle.Fill;
            this.tbMob.Location = new System.Drawing.Point(113, 33);
            this.tbMob.Name = "tbMob";
            this.tbMob.Size = new System.Drawing.Size(332, 20);
            this.tbMob.TabIndex = 1;
            // 
            // tbExportChannel
            // 
            this.tableLayoutPanel2.SetColumnSpan(this.tbExportChannel, 2);
            this.tbExportChannel.Dock = System.Windows.Forms.DockStyle.Fill;
            this.tbExportChannel.Location = new System.Drawing.Point(113, 123);
            this.tbExportChannel.Name = "tbExportChannel";
            this.tbExportChannel.Size = new System.Drawing.Size(244, 20);
            this.tbExportChannel.TabIndex = 7;
            this.tbExportChannel.Text = "raidsay";
            // 
            // label2
            // 
            this.label2.AutoSize = true;
            this.label2.Dock = System.Windows.Forms.DockStyle.Fill;
            this.label2.Location = new System.Drawing.Point(3, 30);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(104, 30);
            this.label2.TabIndex = 8;
            this.label2.Text = "Mob Name";
            this.label2.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // label7
            // 
            this.label7.AutoSize = true;
            this.label7.Dock = System.Windows.Forms.DockStyle.Fill;
            this.label7.Location = new System.Drawing.Point(3, 120);
            this.label7.Name = "label7";
            this.label7.Size = new System.Drawing.Size(104, 30);
            this.label7.TabIndex = 9;
            this.label7.Text = "Export Channel";
            this.label7.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // label1
            // 
            this.label1.AutoSize = true;
            this.label1.Dock = System.Windows.Forms.DockStyle.Fill;
            this.label1.Location = new System.Drawing.Point(3, 0);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(104, 30);
            this.label1.TabIndex = 10;
            this.label1.Text = "Spell Name";
            this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // tbSpell
            // 
            this.tableLayoutPanel2.SetColumnSpan(this.tbSpell, 4);
            this.tbSpell.Dock = System.Windows.Forms.DockStyle.Fill;
            this.tbSpell.Location = new System.Drawing.Point(113, 3);
            this.tbSpell.Name = "tbSpell";
            this.tbSpell.Size = new System.Drawing.Size(426, 20);
            this.tbSpell.TabIndex = 0;
            // 
            // label3
            // 
            this.label3.AutoSize = true;
            this.label3.Dock = System.Windows.Forms.DockStyle.Fill;
            this.label3.Location = new System.Drawing.Point(3, 90);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(104, 30);
            this.label3.TabIndex = 11;
            this.label3.Text = "Trigger Conditions";
            this.label3.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // label4
            // 
            this.label4.AutoSize = true;
            this.label4.Dock = System.Windows.Forms.DockStyle.Fill;
            this.label4.Location = new System.Drawing.Point(3, 60);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(104, 30);
            this.label4.TabIndex = 12;
            this.label4.Text = "Effect Category";
            this.label4.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // ddlCategory
            // 
            this.ddlCategory.Dock = System.Windows.Forms.DockStyle.Fill;
            this.ddlCategory.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.ddlCategory.FormattingEnabled = true;
            this.ddlCategory.Items.AddRange(new object[] {
            "Emote (Regex)",
            "Any Combat Action",
            "Non-Melee",
            "Power Drain"});
            this.ddlCategory.Location = new System.Drawing.Point(113, 63);
            this.ddlCategory.Name = "ddlCategory";
            this.ddlCategory.Size = new System.Drawing.Size(115, 21);
            this.ddlCategory.TabIndex = 3;
            this.ddlCategory.SelectedIndexChanged += new System.EventHandler(this.ddlCategory_SelectedIndexChanged);
            // 
            // nudPlayerCount
            // 
            this.nudPlayerCount.Dock = System.Windows.Forms.DockStyle.Right;
            this.nudPlayerCount.Location = new System.Drawing.Point(175, 93);
            this.nudPlayerCount.Minimum = new decimal(new int[] {
            1,
            0,
            0,
            0});
            this.nudPlayerCount.Name = "nudPlayerCount";
            this.nudPlayerCount.Size = new System.Drawing.Size(53, 20);
            this.nudPlayerCount.TabIndex = 4;
            this.nudPlayerCount.Value = new decimal(new int[] {
            1,
            0,
            0,
            0});
            // 
            // label5
            // 
            this.label5.AutoSize = true;
            this.label5.Dock = System.Windows.Forms.DockStyle.Fill;
            this.label5.Location = new System.Drawing.Point(234, 90);
            this.label5.Name = "label5";
            this.label5.Size = new System.Drawing.Size(123, 30);
            this.label5.TabIndex = 13;
            this.label5.Text = "Players                OR";
            this.label5.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // nudSecondCount
            // 
            this.nudSecondCount.Dock = System.Windows.Forms.DockStyle.Right;
            this.nudSecondCount.Location = new System.Drawing.Point(392, 93);
            this.nudSecondCount.Name = "nudSecondCount";
            this.nudSecondCount.Size = new System.Drawing.Size(53, 20);
            this.nudSecondCount.TabIndex = 5;
            this.nudSecondCount.Value = new decimal(new int[] {
            1,
            0,
            0,
            0});
            // 
            // label6
            // 
            this.label6.AutoSize = true;
            this.label6.Dock = System.Windows.Forms.DockStyle.Fill;
            this.label6.Location = new System.Drawing.Point(451, 90);
            this.label6.Name = "label6";
            this.label6.Size = new System.Drawing.Size(88, 30);
            this.label6.TabIndex = 14;
            this.label6.Text = "Seconds";
            this.label6.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // cbAnyMob
            // 
            this.cbAnyMob.AutoSize = true;
            this.cbAnyMob.Dock = System.Windows.Forms.DockStyle.Fill;
            this.cbAnyMob.Location = new System.Drawing.Point(451, 33);
            this.cbAnyMob.Name = "cbAnyMob";
            this.cbAnyMob.Size = new System.Drawing.Size(88, 24);
            this.cbAnyMob.TabIndex = 2;
            this.cbAnyMob.Text = "Any";
            this.cbAnyMob.UseVisualStyleBackColor = true;
            this.cbAnyMob.CheckedChanged += new System.EventHandler(this.cbAnyMob_CheckedChanged);
            // 
            // cbSingleLine
            // 
            this.cbSingleLine.AutoSize = true;
            this.tableLayoutPanel2.SetColumnSpan(this.cbSingleLine, 2);
            this.cbSingleLine.Dock = System.Windows.Forms.DockStyle.Fill;
            this.cbSingleLine.Location = new System.Drawing.Point(363, 123);
            this.cbSingleLine.Name = "cbSingleLine";
            this.cbSingleLine.Size = new System.Drawing.Size(176, 24);
            this.cbSingleLine.TabIndex = 15;
            this.cbSingleLine.Text = "Export list to only one line";
            this.cbSingleLine.UseVisualStyleBackColor = true;
            // 
            // label9
            // 
            this.label9.AutoSize = true;
            this.label9.Dock = System.Windows.Forms.DockStyle.Fill;
            this.label9.Location = new System.Drawing.Point(3, 150);
            this.label9.Name = "label9";
            this.label9.Size = new System.Drawing.Size(104, 30);
            this.label9.TabIndex = 16;
            this.label9.Text = "Export Format";
            this.label9.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // tbExportFormat
            // 
            this.tableLayoutPanel2.SetColumnSpan(this.tbExportFormat, 4);
            this.tbExportFormat.Dock = System.Windows.Forms.DockStyle.Fill;
            this.tbExportFormat.Location = new System.Drawing.Point(113, 153);
            this.tbExportFormat.Name = "tbExportFormat";
            this.tbExportFormat.Size = new System.Drawing.Size(426, 20);
            this.tbExportFormat.TabIndex = 8;
            this.tbExportFormat.Text = ">>> {0} <<< has {1}";
            // 
            // lblInstructions
            // 
            this.lblInstructions.AutoSize = true;
            this.tableLayoutPanel2.SetColumnSpan(this.lblInstructions, 5);
            this.lblInstructions.Dock = System.Windows.Forms.DockStyle.Fill;
            this.lblInstructions.ForeColor = System.Drawing.SystemColors.ControlDarkDark;
            this.lblInstructions.Location = new System.Drawing.Point(3, 240);
            this.lblInstructions.Name = "lblInstructions";
            this.lblInstructions.Size = new System.Drawing.Size(536, 234);
            this.lblInstructions.TabIndex = 17;
            this.lblInstructions.Text = "<Instructions>";
            // 
            // label8
            // 
            this.label8.AutoSize = true;
            this.label8.Dock = System.Windows.Forms.DockStyle.Fill;
            this.label8.Location = new System.Drawing.Point(3, 180);
            this.label8.Name = "label8";
            this.label8.Size = new System.Drawing.Size(104, 30);
            this.label8.TabIndex = 18;
            this.label8.Text = "Trigger Sound";
            this.label8.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // ddlSound
            // 
            this.ddlSound.Dock = System.Windows.Forms.DockStyle.Fill;
            this.ddlSound.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.ddlSound.FormattingEnabled = true;
            this.ddlSound.Items.AddRange(new object[] {
            "Beep",
            "Astersk",
            "TTS",
            "Custom TTS",
            "Custom WAV"});
            this.ddlSound.Location = new System.Drawing.Point(113, 183);
            this.ddlSound.Name = "ddlSound";
            this.ddlSound.Size = new System.Drawing.Size(115, 21);
            this.ddlSound.TabIndex = 9;
            this.ddlSound.SelectedIndexChanged += new System.EventHandler(this.ddlSound_SelectedIndexChanged);
            // 
            // tbSound
            // 
            this.tableLayoutPanel2.SetColumnSpan(this.tbSound, 3);
            this.tbSound.Enabled = false;
            this.tbSound.Location = new System.Drawing.Point(234, 183);
            this.tbSound.Name = "tbSound";
            this.tbSound.Size = new System.Drawing.Size(266, 20);
            this.tbSound.TabIndex = 10;
            this.tbSound.MouseUp += new System.Windows.Forms.MouseEventHandler(this.tbSound_MouseUp);
            // 
            // label11
            // 
            this.label11.AutoSize = true;
            this.label11.Dock = System.Windows.Forms.DockStyle.Fill;
            this.label11.Location = new System.Drawing.Point(3, 210);
            this.label11.Name = "label11";
            this.label11.Size = new System.Drawing.Size(104, 30);
            this.label11.TabIndex = 19;
            this.label11.Text = "Export File";
            this.label11.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // tbExFilename
            // 
            this.tableLayoutPanel2.SetColumnSpan(this.tbExFilename, 2);
            this.tbExFilename.Dock = System.Windows.Forms.DockStyle.Fill;
            this.tbExFilename.Location = new System.Drawing.Point(113, 213);
            this.tbExFilename.Name = "tbExFilename";
            this.tbExFilename.Size = new System.Drawing.Size(244, 20);
            this.tbExFilename.TabIndex = 20;
            // 
            // label12
            // 
            this.label12.AutoSize = true;
            this.tableLayoutPanel2.SetColumnSpan(this.label12, 2);
            this.label12.Dock = System.Windows.Forms.DockStyle.Fill;
            this.label12.Location = new System.Drawing.Point(363, 210);
            this.label12.Name = "label12";
            this.label12.Size = new System.Drawing.Size(176, 30);
            this.label12.TabIndex = 21;
            this.label12.Text = "Leave blank for \"detriment.txt\"";
            this.label12.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // cbShowDetWindow
            // 
            this.cbShowDetWindow.AutoSize = true;
            this.cbShowDetWindow.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.cbShowDetWindow.Location = new System.Drawing.Point(218, 15);
            this.cbShowDetWindow.Name = "cbShowDetWindow";
            this.cbShowDetWindow.Size = new System.Drawing.Size(174, 17);
            this.cbShowDetWindow.TabIndex = 2;
            this.cbShowDetWindow.Text = "Show Live Export Window";
            this.cbShowDetWindow.UseVisualStyleBackColor = true;
            this.cbShowDetWindow.CheckedChanged += new System.EventHandler(this.cbShowDetWindow_CheckedChanged);
            // 
            // btnPlayTrigger
            // 
            this.btnPlayTrigger.Location = new System.Drawing.Point(719, 221);
            this.btnPlayTrigger.Name = "btnPlayTrigger";
            this.btnPlayTrigger.Size = new System.Drawing.Size(38, 20);
            this.btnPlayTrigger.TabIndex = 3;
            this.btnPlayTrigger.Text = "|>";
            this.btnPlayTrigger.UseVisualStyleBackColor = true;
            this.btnPlayTrigger.Click += new System.EventHandler(this.btnPlayTrigger_Click);
            // 
            // DetrimentCallMacro
            // 
            this.Controls.Add(this.btnPlayTrigger);
            this.Controls.Add(this.cbShowDetWindow);
            this.Controls.Add(this.tableLayoutPanel2);
            this.Controls.Add(this.tableLayoutPanel1);
            this.Name = "DetrimentCallMacro";
            this.Size = new System.Drawing.Size(993, 597);
            this.tableLayoutPanel1.ResumeLayout(false);
            this.tableLayoutPanel2.ResumeLayout(false);
            this.tableLayoutPanel2.PerformLayout();
            ((System.ComponentModel.ISupportInitialize)(this.nudPlayerCount)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.nudSecondCount)).EndInit();
            this.ResumeLayout(false);
            this.PerformLayout();

        }

        #endregion
        Label lblPluginStatus;
        Timer tmr;
        DetrimentForm detrimentForm;
        DateTime lastExport;
        bool parseRaid = false;
        Dictionary<string, int> playerGroups = new Dictionary<string, int>();
        Regex whoplayerRegex = new Regex(@"\[\d+ \w+\] (\w+) \(.+\)", RegexOptions.Compiled);

        public DetrimentCallMacro()
        {
            InitializeComponent();
            #region lblInstructions
            lblInstructions.Text = @"In the above export formatting, {0} will be replaced by the player name or list of players. {2} will be replaced by the playername and group number if known(use /whoraid before pull).  {1} will be replaced by the spell name being tracked.

In the case of the spell name being an emote/regular expression, you should set the spell name using a comment block: IE, ""(?#SpellName)"".  The player name in the regular expression will be extracted as the first capuring group in a match.

For custom TTS, {0} will be replaced by an affected players list and {1} will be replaced by the spell name(or regex comment).

To execute the export in EQ2, type: /do_file_commands detriment.txt   (or chosen filename)";
            #endregion
        }

        public void InitPlugin(TabPage pluginScreenSpace, Label pluginStatusText)
        {
            lblPluginStatus = pluginStatusText;
            pluginScreenSpace.Controls.Add(this);
            this.Dock = DockStyle.Fill;
            detrimentForm = new DetrimentForm();
            lastExport = ActGlobals.oFormActMain.LastEstimatedTime;
            tmr = new Timer();
            tmr.Interval = 500;
            tmr.Tick += new EventHandler(tmr_Tick);
            tmr.Enabled = true;
            ActGlobals.oFormActMain.AfterCombatAction += new CombatActionDelegate(oFormActMain_AfterCombatAction);
            ActGlobals.oFormActMain.OnLogLineRead += new LogLineEventDelegate(oFormActMain_OnLogLineRead);
            LoadXmlSettings();
            lblPluginStatus.Text = "Plugin Started\nClick to show/hide the detriment status window.";
            lblPluginStatus.Click += new EventHandler(lblPluginStatus_Click);
        }

        public void DeInitPlugin()
        {
            tmr.Enabled = false;
            ActGlobals.oFormActMain.AfterCombatAction -= oFormActMain_AfterCombatAction;
            ActGlobals.oFormActMain.OnLogLineRead -= oFormActMain_OnLogLineRead;
            SaveXmlSettings();
            detrimentForm.Dispose();
            lblPluginStatus.Text = "Plugin Stopped";
        }

        private void cbShowDetWindow_CheckedChanged(object sender, EventArgs e)
        {
            detrimentForm.Visible = cbShowDetWindow.Checked;
        }
        void lblPluginStatus_Click(object sender, EventArgs e)
        {
            cbShowDetWindow.Checked = !cbShowDetWindow.Checked;
        }
        void tbSound_MouseUp(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left && ddlSound.SelectedIndex == 4)
            {
                OpenFileDialog fd = new OpenFileDialog();
                fd.FileName = tbSound.Text;
                fd.Multiselect = false;
                fd.CheckFileExists = true;
                fd.Filter = "(*.wav) Waveform Files|*.wav";

                DialogResult result = fd.ShowDialog();
                if (result == DialogResult.OK)
                    tbSound.Text = fd.FileName;
            }
        }
        void ddlSound_SelectedIndexChanged(object sender, EventArgs e)
        {
            switch (ddlSound.SelectedIndex)
            {
                case 0: // Beep
                    tbSound.Text = string.Empty;
                    tbSound.Enabled = false;
                    break;
                case 1: // Asterisk
                    tbSound.Text = string.Empty;
                    tbSound.Enabled = false;
                    break;
                case 2: // TTS
                    tbSound.Text = string.Empty;
                    tbSound.Enabled = false;
                    break;
                case 3: // Custom TTS
                    tbSound.Enabled = true;
                    break;
                case 4: // Custom WAV
                    tbSound.Enabled = true;
                    break;
            }
        }
        void ddlCategory_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (ddlCategory.SelectedIndex == 0)
            {
                cbAnyMob.Checked = true;
                cbAnyMob.Enabled = false;
            }
            else
            {
                cbAnyMob.Enabled = true;
            }
        }
        void clbEffects_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (clbEffects.SelectedIndex != -1)
            {
                EffectTrigger eff = (EffectTrigger)clbEffects.Items[clbEffects.SelectedIndex];
                tbMob.Text = eff.mob;
                cbAnyMob.Checked = eff.anyMob;
                tbSpell.Text = eff.spell;
                ddlCategory.SelectedIndex = eff.effCategory;
                cbSingleLine.Checked = eff.singleLine;
                nudPlayerCount.Value = eff.playerCount;
                nudSecondCount.Value = eff.waitCount;
                tbExportChannel.Text = eff.exportChannel;
                tbExFilename.Text = eff.exportFilename;
                tbExportFormat.Text = eff.exportFormat;
                ddlSound.SelectedIndex = eff.soundType;
                tbSound.Text = eff.soundData;
            }
        }
        void btnAdd_Click(object sender, EventArgs e)
        {
            EffectTrigger eff = new EffectTrigger(cbAnyMob.Checked, tbMob.Text, tbSpell.Text, ddlCategory.SelectedIndex, (int)nudPlayerCount.Value,
                (int)nudSecondCount.Value, tbExportChannel.Text, tbExFilename.Text, tbExportFormat.Text, cbSingleLine.Checked, ddlSound.SelectedIndex, tbSound.Text);
            int index = clbEffects.Items.IndexOf(eff);
            if (index == -1)
            {
                clbEffects.Items.Add(eff);
                clbEffects.SetItemChecked(clbEffects.Items.Count - 1, true);
            }
            else
                clbEffects.Items[index] = eff;
        }
        void btnRemove_Click(object sender, EventArgs e)
        {
            if (clbEffects.SelectedIndex != -1)
                clbEffects.Items.RemoveAt(clbEffects.SelectedIndex);
        }
        void cbAnyMob_CheckedChanged(object sender, EventArgs e)
        {
            if (cbAnyMob.Checked)
            {
                tbMob.Text = string.Empty;
                tbMob.Enabled = false;
            }
            else
                tbMob.Enabled = true;
        }

        void oFormActMain_AfterCombatAction(bool isImport, CombatActionEventArgs actionInfo)
        {
            if (isImport)
                return;
            for (int i = 0; i < clbEffects.Items.Count; i++)
            {
                EffectTrigger eff = (EffectTrigger)clbEffects.Items[i];
                switch (eff.effCategory)
                {
                    case 0:	// Regex
                        continue;
                    case 2: // Non-Melee
                        if (actionInfo.swingType != (int)SwingTypeEnum.NonMelee)
                            continue;
                        break;
                    case 3: // Power Drain
                        if (actionInfo.swingType != (int)SwingTypeEnum.PowerDrain)
                            continue;
                        break;
                }
                if (eff.anyMob || actionInfo.attacker == eff.mob)
                {
                    if (actionInfo.theAttackType == eff.spell)
                    {
                        eff.AddPlayer(actionInfo.victim);
                    }
                }
            }
        }
        void oFormActMain_OnLogLineRead(bool isImport, LogLineEventArgs logInfo)
        {
            if (isImport)
                return;
            for (int i = 0; i < clbEffects.Items.Count; i++)
            {
                EffectTrigger eff = (EffectTrigger)clbEffects.Items[i];
                if (eff.effCategory == 0)
                {
                    string logLine = logInfo.logLine.Substring(ActGlobals.oFormActMain.TimeStampLen);
                    if (eff.emoteRegex.IsMatch(logLine))
                    {
                        string player = eff.emoteRegex.Replace(logLine, "$1");
                        eff.AddPlayer(player);
                    }
                }
            }
            if (logInfo.logLine.Substring(ActGlobals.oFormActMain.TimeStampLen).StartsWith("/whoraid search results for"))
            {
                parseRaid = true;
                playerGroups.Clear();
            }
            if (parseRaid)
            {
                string logLine = logInfo.logLine.Substring(ActGlobals.oFormActMain.TimeStampLen);
                if (whoplayerRegex.IsMatch(logLine))
                    playerGroups.Add(whoplayerRegex.Replace(logLine, "$1"), playerGroups.Count / 6 + 1);
            }
            if (parseRaid && logInfo.logLine.EndsWith(" players found"))
            {
                parseRaid = false;
                if (playerGroups.Count < 24)
                    playerGroups.Clear();
            }
        }
        void tmr_Tick(object sender, EventArgs e)
        {
            TimeSpan tsLastExport = ActGlobals.oFormActMain.LastEstimatedTime - lastExport;
            detrimentForm.Text = String.Format("Detriments (Last was {0:0,0}s ago)", tsLastExport.TotalSeconds);
            for (int i = 0; i < clbEffects.Items.Count; i++)
            {
                if (clbEffects.GetItemChecked(i))
                {
                    EffectTrigger eff = (EffectTrigger)clbEffects.Items[i];
                    if (eff.IsTriggerMet())
                    {
                        lastExport = ActGlobals.oFormActMain.LastEstimatedTime;
                        string effectName = String.IsNullOrEmpty(eff.shortName) ? eff.spell : eff.shortName;
                        StringBuilder sb = new StringBuilder();
                        if (eff.singleLine)
                        {
                            string concatPlayers = string.Empty;
                            for (int j = 0; j < eff.players.Count; j++)
                                concatPlayers += String.Format("{0}, ", eff.players[j]);
                            concatPlayers = concatPlayers.TrimEnd(new char[] { ' ', ',' });

                            string concatPlayersGroup = string.Empty;
                            try
                            {
                                if (playerGroups.Count > 0)
                                {
                                    for (int j = 0; j < eff.players.Count; j++)
                                        concatPlayersGroup += String.Format("{0}(G{1}), ", eff.players[j], playerGroups[eff.players[j]]);
                                    concatPlayersGroup = concatPlayersGroup.TrimEnd(new char[] { ' ', ',' });
                                }
                            }
                            catch
                            {
                                playerGroups.Clear();
                                concatPlayersGroup = string.Empty;
                            }
                            sb.AppendLine(String.Format(eff.exportFormat, concatPlayers, effectName, String.IsNullOrEmpty(concatPlayersGroup) ? concatPlayers : concatPlayersGroup));
                        }
                        else
                        {
                            for (int j = 0; j < eff.players.Count; j++)
                            {
                                string playerGroup = string.Empty;
                                try
                                {
                                    playerGroup = String.Format("{0}(G{1})", eff.players[j], playerGroups[eff.players[j]]);
                                }
                                catch
                                {
                                    playerGroup = string.Empty;
                                    playerGroups.Clear();
                                }
                                sb.AppendLine(String.Format(eff.exportFormat, eff.players[j], effectName, String.IsNullOrEmpty(playerGroup) ? eff.players[j] : playerGroup));
                            }
                        }
                        ActGlobals.oFormActMain.SendToMacroFile(String.IsNullOrEmpty(eff.exportFilename) ? "detriment.txt" : eff.exportFilename, sb.ToString(), eff.exportChannel);
                        detrimentForm.rtb.Text = sb.ToString();
                        try
                        {
                            eff.TriggerSound();
                        }
                        catch (Exception ex)
                        {
                            ActGlobals.oFormActMain.WriteExceptionLog(ex, "EffectTrigger Sound");
                            System.Media.SystemSounds.Beep.Play();
                        }
                        eff.ResetList();
                    }
                }
            }
        }

        private void LoadXmlSettings()
        {
            string path = Path.Combine(ActGlobals.oFormActMain.AppDataFolder.FullName, "Config\\DetrimentCallMacro.config.xml");
            if (!File.Exists(path))
                return;
            XmlDocument xml = new XmlDocument();
            xml.Load(path);

            foreach (XmlNode node1 in xml.ChildNodes[1].ChildNodes)
            {
                switch (node1.Name)
                {
                    case "DetrimentWindow":
                        cbShowDetWindow.Checked = Boolean.Parse(node1.Attributes["Visible"].Value);
                        detrimentForm.Left = Int32.Parse(node1.Attributes["X"].Value);
                        detrimentForm.Top = Int32.Parse(node1.Attributes["Y"].Value);
                        detrimentForm.Width = Int32.Parse(node1.Attributes["W"].Value);
                        detrimentForm.Height = Int32.Parse(node1.Attributes["H"].Value);
                        break;
                    case "EffectTriggers":
                        foreach (XmlNode node2 in node1.ChildNodes)
                        {
                            string exportFilename = string.Empty;
                            try
                            {
                                exportFilename = node2.Attributes["ExportFilename"].Value;
                            }
                            catch
                            {
                                exportFilename = string.Empty;
                            }
                            EffectTrigger eff = new EffectTrigger(Boolean.Parse(node2.Attributes["AnyMob"].Value), node2.Attributes["Mob"].Value,
                                node2.Attributes["Spell"].Value, Int32.Parse(node2.Attributes["EffCategory"].Value),
                                Int32.Parse(node2.Attributes["PlayerCount"].Value), Int32.Parse(node2.Attributes["WaitCount"].Value),
                                node2.Attributes["ExportChannel"].Value, exportFilename, node2.Attributes["ExportFormat"].Value,
                                Boolean.Parse(node2.Attributes["SingleLine"].Value), Int32.Parse(node2.Attributes["SoundType"].Value),
                                node2.Attributes["SoundData"].Value);
                            clbEffects.Items.Add(eff);
                            clbEffects.SetItemChecked(clbEffects.Items.Count - 1, Boolean.Parse(node2.Attributes["Checked"].Value));
                        }
                        break;
                }
            }
        }
        private void SaveXmlSettings()
        {
            string path = Path.Combine(ActGlobals.oFormActMain.AppDataFolder.FullName, "Config\\DetrimentCallMacro.config.xml");
            XmlTextWriter xml = new XmlTextWriter(path, Encoding.UTF8);
            xml.Formatting = Formatting.Indented;
            xml.Indentation = 4;
            xml.Namespaces = false;

            xml.WriteStartDocument();

            xml.WriteStartElement("", "Config", "");

            detrimentForm.WindowState = FormWindowState.Normal;
            xml.WriteStartElement("", "DetrimentWindow", "");
            xml.WriteAttributeString("Visible", cbShowDetWindow.Checked.ToString());
            xml.WriteAttributeString("X", detrimentForm.Left.ToString());
            xml.WriteAttributeString("Y", detrimentForm.Top.ToString());
            xml.WriteAttributeString("W", detrimentForm.Width.ToString());
            xml.WriteAttributeString("H", detrimentForm.Height.ToString());
            xml.WriteEndElement();

            xml.WriteStartElement("", "EffectTriggers", "");
            for (int i = 0; i < clbEffects.Items.Count; i++)
            {
                EffectTrigger eff = (EffectTrigger)clbEffects.Items[i];
                xml.WriteStartElement("", "EffectTrigger", "");
                xml.WriteAttributeString("Checked", clbEffects.GetItemChecked(i).ToString());
                xml.WriteAttributeString("AnyMob", eff.anyMob.ToString());
                xml.WriteAttributeString("EffCategory", eff.effCategory.ToString());
                xml.WriteAttributeString("ExportChannel", eff.exportChannel.ToString());
                xml.WriteAttributeString("ExportFilename", eff.exportFilename.ToString());
                xml.WriteAttributeString("ExportFormat", eff.exportFormat.ToString());
                xml.WriteAttributeString("Mob", eff.mob.ToString());
                xml.WriteAttributeString("SingleLine", eff.singleLine.ToString());
                xml.WriteAttributeString("PlayerCount", eff.playerCount.ToString());
                xml.WriteAttributeString("WaitCount", eff.waitCount.ToString());
                xml.WriteAttributeString("Spell", eff.spell.ToString());
                xml.WriteAttributeString("SoundType", eff.soundType.ToString());
                xml.WriteAttributeString("SoundData", eff.soundData.ToString());
                xml.WriteEndElement();
            }
            xml.WriteEndElement();

            xml.WriteEndElement();

            xml.WriteEndDocument();
            xml.Flush();
            xml.Close();
        }

        private class EffectTrigger : IEquatable<EffectTrigger>
        {
            internal static Regex findComment = new Regex(@".*?\(\?#([^\)]+)\).*", RegexOptions.Compiled);
            DateTime firstUpdate = DateTime.MinValue;
            public readonly string shortName = string.Empty;
            public readonly string spell, mob, exportChannel, exportFormat, soundData, exportFilename;
            public readonly bool anyMob, singleLine;
            public readonly int effCategory, playerCount, waitCount, soundType;
            public readonly Regex emoteRegex;
            public readonly List<string> players = new List<string>();

            public EffectTrigger(bool AnyMob, string MobName, string SpellName, int EffectCategory, int PlayerCount, int WaitCount,
                string ExportChannel, string ExportFilename, string ExportFormat, bool SingleLineExport, int SoundType, string SoundData)
            {
                anyMob = AnyMob;
                spell = SpellName;
                mob = MobName;
                effCategory = EffectCategory;
                playerCount = PlayerCount;
                waitCount = WaitCount;
                exportChannel = ExportChannel;
                exportFilename = ExportFilename;
                exportFormat = ExportFormat;
                singleLine = SingleLineExport;
                soundType = SoundType;
                soundData = SoundData;
                if (effCategory == 0)
                {
                    emoteRegex = new Regex(spell, RegexOptions.Compiled);
                    shortName = findComment.Replace(spell, "$1");
                }
            }
            public void AddPlayer(string Player)
            {
                if (!players.Contains(Player))
                    players.Add(Player);
                if (firstUpdate == DateTime.MinValue)
                    firstUpdate = ActGlobals.oFormActMain.LastEstimatedTime;
            }
            public void ResetList()
            {
                players.Clear();
                firstUpdate = DateTime.MinValue;
            }
            public bool IsTriggerMet()
            {
                if (players.Count >= playerCount)
                    return true;
                if (firstUpdate != DateTime.MinValue && players.Count > 0 &&
                    ActGlobals.oFormActMain.LastEstimatedTime - firstUpdate >= TimeSpan.FromSeconds(waitCount) && waitCount != 0)
                    return true;
                return false;
            }
            public void TriggerSound()
            {
                switch (soundType)
                {
                    case 0: // Beep
                        System.Media.SystemSounds.Beep.Play();
                        break;
                    case 1: // Asterisk
                        System.Media.SystemSounds.Asterisk.Play();
                        break;
                    case 2: // TTS
                        ActGlobals.oFormActMain.TTS(this.ToString());
                        break;
                    case 3: // Custom TTS
                        string concatPlayers = string.Empty;
                        for (int j = 0; j < players.Count; j++)
                            concatPlayers += String.Format("{0}, ", players[j]);
                        ActGlobals.oFormActMain.TTS(String.Format(soundData, concatPlayers, String.IsNullOrEmpty(shortName) ? spell : shortName));
                        break;
                    case 4: // Custom WAV
                        ActGlobals.oFormActMain.PlaySound(soundData);
                        break;
                }
            }
            public override int GetHashCode()
            {
                return String.Format("{0}{1}{2}{3}{4}{5}{6}{7}{8}", spell, mob, exportChannel, exportFormat, anyMob, singleLine, effCategory, playerCount, waitCount).GetHashCode();
            }
            public override bool Equals(object obj)
            {
                if (obj.GetType().FullName == "System.DBNull")
                    return false;
                if (obj == null)
                    return false;
                EffectTrigger r = (EffectTrigger)obj;
                return this.Equals(r);
            }
            public bool Equals(EffectTrigger other)
            {
                return this.ToString().Equals(other.ToString());
            }
            public override string ToString()
            {
                if (!String.IsNullOrEmpty(shortName))
                    return shortName;
                return String.Format("({0}) {1}", mob, spell);
            }
        }

        private void btnPlayTrigger_Click(object sender, EventArgs e)
        {
            try
            {
                switch (ddlSound.SelectedIndex)
                {
                    case 0: // Beep
                        System.Media.SystemSounds.Beep.Play();
                        break;
                    case 1: // Asterisk
                        System.Media.SystemSounds.Asterisk.Play();
                        break;
                    case 2: // TTS
                        ActGlobals.oFormActMain.TTS(tbSound.Text);
                        break;
                    case 3: // Custom TTS
                        string concatPlayers = "Player Name";
                        string shortName = EffectTrigger.findComment.Replace(tbSpell.Text, "$1");
                        ActGlobals.oFormActMain.TTS(String.Format(tbSound.Text, concatPlayers, String.IsNullOrEmpty(shortName) ? tbSpell.Text : shortName));
                        break;
                    case 4: // Custom WAV
                        ActGlobals.oFormActMain.PlaySound(tbSound.Text);
                        break;
                }
            }
            catch (Exception ex)
            {
                ActGlobals.oFormActMain.WriteExceptionLog(ex, "Sound Preview");
            }
        }
    }
    class DetrimentForm : Form
    {
        public readonly RichTextBox rtb;
        public DetrimentForm()
        {
            rtb = new RichTextBox();
            rtb.Dock = DockStyle.Fill;
            rtb.BackColor = Color.Black;
            rtb.ForeColor = Color.White;
            rtb.Font = new Font("Arial", 14F);
            rtb.ReadOnly = true;
            this.Controls.Add(rtb);
            this.Size = new Size(450, 150);
            this.FormBorderStyle = FormBorderStyle.SizableToolWindow;
            this.StartPosition = FormStartPosition.Manual;
            this.TopMost = true;
            FormClosing += new FormClosingEventHandler(DetrimentForm_FormClosing);
        }
        void DetrimentForm_FormClosing(object sender, FormClosingEventArgs e)
        {
            e.Cancel = true;
            this.Hide();
        }
    }
}
